Index: trunk/sources/HeuristicLab.Hive.Client.Communication/3.2/Service References/ServerService/Reference.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Client.Communication/3.2/Service References/ServerService/Reference.cs	(revision 2591)
+++ trunk/sources/HeuristicLab.Hive.Client.Communication/3.2/Service References/ServerService/Reference.cs	(revision 3011)
@@ -1,3 +1,3 @@
-﻿//------------------------------------------------------------------------------
+//------------------------------------------------------------------------------
 // <auto-generated>
 //     This code was generated by a tool.
@@ -22,8 +22,8 @@
         [System.ServiceModel.ServiceKnownTypeAttribute(typeof(HeuristicLab.Hive.Contracts.ResponseResultReceived))]
         [System.ServiceModel.ServiceKnownTypeAttribute(typeof(HeuristicLab.Hive.Contracts.ResponsePlugin))]
-        HeuristicLab.Hive.Contracts.Response Login(HeuristicLab.Hive.Contracts.BusinessObjects.ClientInfo clientInfo);
+        HeuristicLab.Hive.Contracts.Response Login(HeuristicLab.Hive.Contracts.BusinessObjects.ClientDto clientInfo);
         
         [System.ServiceModel.OperationContractAttribute(AsyncPattern=true, Action="http://tempuri.org/IClientCommunicator/Login", ReplyAction="http://tempuri.org/IClientCommunicator/LoginResponse")]
-        System.IAsyncResult BeginLogin(HeuristicLab.Hive.Contracts.BusinessObjects.ClientInfo clientInfo, System.AsyncCallback callback, object asyncState);
+        System.IAsyncResult BeginLogin(HeuristicLab.Hive.Contracts.BusinessObjects.ClientDto clientInfo, System.AsyncCallback callback, object asyncState);
         
         HeuristicLab.Hive.Contracts.Response EndLogin(System.IAsyncResult result);
@@ -96,8 +96,8 @@
         
         [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IClientCommunicator/SendPlugins", ReplyAction="http://tempuri.org/IClientCommunicator/SendPluginsResponse")]
-        HeuristicLab.Hive.Contracts.ResponsePlugin SendPlugins(HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfo[] pluginList);
+        HeuristicLab.Hive.Contracts.ResponsePlugin SendPlugins(HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfoDto[] pluginList);
         
         [System.ServiceModel.OperationContractAttribute(AsyncPattern=true, Action="http://tempuri.org/IClientCommunicator/SendPlugins", ReplyAction="http://tempuri.org/IClientCommunicator/SendPluginsResponse")]
-        System.IAsyncResult BeginSendPlugins(HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfo[] pluginList, System.AsyncCallback callback, object asyncState);
+        System.IAsyncResult BeginSendPlugins(HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfoDto[] pluginList, System.AsyncCallback callback, object asyncState);
         
         HeuristicLab.Hive.Contracts.ResponsePlugin EndSendPlugins(System.IAsyncResult result);
@@ -112,8 +112,8 @@
         
         [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IClientFacade/SendStreamedPlugins", ReplyAction="http://tempuri.org/IClientFacade/SendStreamedPluginsResponse")]
-        System.IO.Stream SendStreamedPlugins(HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfo[] pluginList);
+        System.IO.Stream SendStreamedPlugins(HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfoDto[] pluginList);
         
         [System.ServiceModel.OperationContractAttribute(AsyncPattern=true, Action="http://tempuri.org/IClientFacade/SendStreamedPlugins", ReplyAction="http://tempuri.org/IClientFacade/SendStreamedPluginsResponse")]
-        System.IAsyncResult BeginSendStreamedPlugins(HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfo[] pluginList, System.AsyncCallback callback, object asyncState);
+        System.IAsyncResult BeginSendStreamedPlugins(HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfoDto[] pluginList, System.AsyncCallback callback, object asyncState);
         
         System.IO.Stream EndSendStreamedPlugins(System.IAsyncResult result);
@@ -521,10 +521,10 @@
         public event System.EventHandler<ProcessSnapshotStreamedCompletedEventArgs> ProcessSnapshotStreamedCompleted;
         
-        public HeuristicLab.Hive.Contracts.Response Login(HeuristicLab.Hive.Contracts.BusinessObjects.ClientInfo clientInfo) {
+        public HeuristicLab.Hive.Contracts.Response Login(HeuristicLab.Hive.Contracts.BusinessObjects.ClientDto clientInfo) {
             return base.Channel.Login(clientInfo);
         }
         
         [System.ComponentModel.EditorBrowsableAttribute(System.ComponentModel.EditorBrowsableState.Advanced)]
-        public System.IAsyncResult BeginLogin(HeuristicLab.Hive.Contracts.BusinessObjects.ClientInfo clientInfo, System.AsyncCallback callback, object asyncState) {
+        public System.IAsyncResult BeginLogin(HeuristicLab.Hive.Contracts.BusinessObjects.ClientDto clientInfo, System.AsyncCallback callback, object asyncState) {
             return base.Channel.BeginLogin(clientInfo, callback, asyncState);
         }
@@ -536,5 +536,5 @@
         
         private System.IAsyncResult OnBeginLogin(object[] inValues, System.AsyncCallback callback, object asyncState) {
-            HeuristicLab.Hive.Contracts.BusinessObjects.ClientInfo clientInfo = ((HeuristicLab.Hive.Contracts.BusinessObjects.ClientInfo)(inValues[0]));
+            HeuristicLab.Hive.Contracts.BusinessObjects.ClientDto clientInfo = ((HeuristicLab.Hive.Contracts.BusinessObjects.ClientDto)(inValues[0]));
             return this.BeginLogin(clientInfo, callback, asyncState);
         }
@@ -553,9 +553,9 @@
         }
         
-        public void LoginAsync(HeuristicLab.Hive.Contracts.BusinessObjects.ClientInfo clientInfo) {
+        public void LoginAsync(HeuristicLab.Hive.Contracts.BusinessObjects.ClientDto clientInfo) {
             this.LoginAsync(clientInfo, null);
         }
         
-        public void LoginAsync(HeuristicLab.Hive.Contracts.BusinessObjects.ClientInfo clientInfo, object userState) {
+        public void LoginAsync(HeuristicLab.Hive.Contracts.BusinessObjects.ClientDto clientInfo, object userState) {
             if ((this.onBeginLoginDelegate == null)) {
                 this.onBeginLoginDelegate = new BeginOperationDelegate(this.OnBeginLogin);
@@ -937,10 +937,10 @@
         }
         
-        public HeuristicLab.Hive.Contracts.ResponsePlugin SendPlugins(HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfo[] pluginList) {
+        public HeuristicLab.Hive.Contracts.ResponsePlugin SendPlugins(HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfoDto[] pluginList) {
             return base.Channel.SendPlugins(pluginList);
         }
         
         [System.ComponentModel.EditorBrowsableAttribute(System.ComponentModel.EditorBrowsableState.Advanced)]
-        public System.IAsyncResult BeginSendPlugins(HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfo[] pluginList, System.AsyncCallback callback, object asyncState) {
+        public System.IAsyncResult BeginSendPlugins(HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfoDto[] pluginList, System.AsyncCallback callback, object asyncState) {
             return base.Channel.BeginSendPlugins(pluginList, callback, asyncState);
         }
@@ -952,5 +952,5 @@
         
         private System.IAsyncResult OnBeginSendPlugins(object[] inValues, System.AsyncCallback callback, object asyncState) {
-            HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfo[] pluginList = ((HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfo[])(inValues[0]));
+            HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfoDto[] pluginList = ((HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfoDto[])(inValues[0]));
             return this.BeginSendPlugins(pluginList, callback, asyncState);
         }
@@ -969,9 +969,9 @@
         }
         
-        public void SendPluginsAsync(HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfo[] pluginList) {
+        public void SendPluginsAsync(HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfoDto[] pluginList) {
             this.SendPluginsAsync(pluginList, null);
         }
         
-        public void SendPluginsAsync(HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfo[] pluginList, object userState) {
+        public void SendPluginsAsync(HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfoDto[] pluginList, object userState) {
             if ((this.onBeginSendPluginsDelegate == null)) {
                 this.onBeginSendPluginsDelegate = new BeginOperationDelegate(this.OnBeginSendPlugins);
@@ -1037,10 +1037,10 @@
         }
         
-        public System.IO.Stream SendStreamedPlugins(HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfo[] pluginList) {
+        public System.IO.Stream SendStreamedPlugins(HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfoDto[] pluginList) {
             return base.Channel.SendStreamedPlugins(pluginList);
         }
         
         [System.ComponentModel.EditorBrowsableAttribute(System.ComponentModel.EditorBrowsableState.Advanced)]
-        public System.IAsyncResult BeginSendStreamedPlugins(HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfo[] pluginList, System.AsyncCallback callback, object asyncState) {
+        public System.IAsyncResult BeginSendStreamedPlugins(HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfoDto[] pluginList, System.AsyncCallback callback, object asyncState) {
             return base.Channel.BeginSendStreamedPlugins(pluginList, callback, asyncState);
         }
@@ -1052,5 +1052,5 @@
         
         private System.IAsyncResult OnBeginSendStreamedPlugins(object[] inValues, System.AsyncCallback callback, object asyncState) {
-            HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfo[] pluginList = ((HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfo[])(inValues[0]));
+            HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfoDto[] pluginList = ((HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfoDto[])(inValues[0]));
             return this.BeginSendStreamedPlugins(pluginList, callback, asyncState);
         }
@@ -1069,9 +1069,9 @@
         }
         
-        public void SendStreamedPluginsAsync(HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfo[] pluginList) {
+        public void SendStreamedPluginsAsync(HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfoDto[] pluginList) {
             this.SendStreamedPluginsAsync(pluginList, null);
         }
         
-        public void SendStreamedPluginsAsync(HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfo[] pluginList, object userState) {
+        public void SendStreamedPluginsAsync(HeuristicLab.Hive.Contracts.BusinessObjects.HivePluginInfoDto[] pluginList, object userState) {
             if ((this.onBeginSendStreamedPluginsDelegate == null)) {
                 this.onBeginSendStreamedPluginsDelegate = new BeginOperationDelegate(this.OnBeginSendStreamedPlugins);
Index: trunk/sources/HeuristicLab.Hive.Client.Communication/3.2/WcfService.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Client.Communication/3.2/WcfService.cs	(revision 2591)
+++ trunk/sources/HeuristicLab.Hive.Client.Communication/3.2/WcfService.cs	(revision 3011)
@@ -1,3 +1,3 @@
-﻿#region License Information
+#region License Information
 /* HeuristicLab
  * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
@@ -151,5 +151,5 @@
     #region Login
     public event System.EventHandler<LoginCompletedEventArgs> LoginCompleted;
-    public void LoginAsync(ClientInfo clientInfo) {
+    public void LoginAsync(ClientDto clientInfo) {
       if (ConnState == NetworkEnum.WcfConnState.Connected)
         proxy.LoginAsync(clientInfo);
@@ -162,5 +162,5 @@
     }
 
-    public void LoginSync(ClientInfo clientInfo) {
+    public void LoginSync(ClientDto clientInfo) {
       try {
         if (ConnState == NetworkEnum.WcfConnState.Connected) {
@@ -372,5 +372,5 @@
     }
 
-    public List<CachedHivePluginInfo> RequestPlugins(List<HivePluginInfo> requestedPlugins) {
+    public List<CachedHivePluginInfoDto> RequestPlugins(List<HivePluginInfoDto> requestedPlugins) {
       try {
         Stream stream = proxy.SendStreamedPlugins(requestedPlugins.ToArray());