Index: trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Creators/RandomPermutationCreator.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Creators/RandomPermutationCreator.cs	(revision 2997)
+++ trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Creators/RandomPermutationCreator.cs	(revision 3017)
@@ -32,5 +32,5 @@
   /// </summary>
   [Item("RandomPermutationCreator", "An operator which creates a new random permutation of integer values.")]
-  [StorableClass(StorableClassType.Empty)]
+  [StorableClass]
   [Creatable("Test")]
   public sealed class RandomPermutationCreator : SingleSuccessorOperator, IPermutationCreator, IStochasticOperator {
Index: trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/CosaCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/CosaCrossover.cs	(revision 2997)
+++ trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/CosaCrossover.cs	(revision 3017)
@@ -35,5 +35,5 @@
   /// </remarks>
   [Item("CosaCrossover", "An operator which performs the crossover described in the COSA optimization method. It is implemented as described in Wendt, O. 1994. COSA: COoperative Simulated Annealing - Integration von Genetischen Algorithmen und Simulated Annealing am Beispiel der Tourenplanung. Dissertation Thesis. IWI Frankfurt.")]
-  [StorableClass(StorableClassType.Empty)]
+  [StorableClass]
   [Creatable("Test")]
   public class CosaCrossover : PermutationCrossover {
Index: trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/CyclicCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/CyclicCrossover.cs	(revision 2997)
+++ trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/CyclicCrossover.cs	(revision 3017)
@@ -32,5 +32,5 @@
   /// </remarks>
   [Item("CyclicCrossover", "An operator which performs the cyclic crossover on two permutations. It is implemented as described in Eiben, A.E. and Smith, J.E. 2003. Introduction to Evolutionary Computation. Natural Computing Series, Springer-Verlag Berlin Heidelberg.")]
-  [StorableClass(StorableClassType.Empty)]
+  [StorableClass]
   [Creatable("Test")]
   public class CyclicCrossover : PermutationCrossover {
Index: trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/CyclicCrossover2.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/CyclicCrossover2.cs	(revision 2997)
+++ trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/CyclicCrossover2.cs	(revision 3017)
@@ -33,5 +33,5 @@
   /// </remarks>
   [Item("CyclicCrossover2", "An operator which performs the cyclic crossover on two permutations. It is implemented as described in Affenzeller, M. et al. 2009. Genetic Algorithms and Genetic Programming - Modern Concepts and Practical Applications. CRC Press. p. 136.")]
-  [StorableClass(StorableClassType.Empty)]
+  [StorableClass]
   [Creatable("Test")]
   public class CyclicCrossover2 : PermutationCrossover {
Index: trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/EdgeRecombinationCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/EdgeRecombinationCrossover.cs	(revision 2997)
+++ trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/EdgeRecombinationCrossover.cs	(revision 3017)
@@ -35,5 +35,5 @@
   /// </remarks>
   [Item("EdgeRecombinationCrossover", "An operator which performs the edge recombination crossover on two permutations. It is implemented as described in Whitley et.al. 1991, The Traveling Salesman and Sequence Scheduling, in Davis, L. (Ed.), Handbook ov Genetic Algorithms, New York, pp. 350-372.")]
-  [StorableClass(StorableClassType.Empty)]
+  [StorableClass]
   [Creatable("Test")]
   public class EdgeRecombinationCrossover : PermutationCrossover {
Index: trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/MaximalPreservativeCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/MaximalPreservativeCrossover.cs	(revision 2997)
+++ trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/MaximalPreservativeCrossover.cs	(revision 3017)
@@ -35,5 +35,5 @@
   /// </remarks>
   [Item("MaximalPreservativeCrossover", "An operator which performs the maximal preservative crossover on two permutations. It is implemented as described in Mühlenbein, H. 1991. Evolution in time and space - the parallel genetic algorithm. FOUNDATIONS OF GENETIC ALGORITHMS, pp. 316-337. Morgan Kaufmann.")]
-  [StorableClass(StorableClassType.Empty)]
+  [StorableClass]
   [Creatable("Test")]
   public class MaximalPreservativeCrossover : PermutationCrossover {
Index: trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/OrderBasedCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/OrderBasedCrossover.cs	(revision 2997)
+++ trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/OrderBasedCrossover.cs	(revision 3017)
@@ -35,5 +35,5 @@
   /// </remarks>
   [Item("OrderBasedCrossover", "An operator which performs an order based crossover of two permutations. It is implemented as described in Syswerda, G. (1991). Schedule Optimization Using Genetic Algorithms. In Davis, L. (Ed.) Handbook of Genetic Algorithms, Van Nostrand Reinhold, New York, pp. 332-349.")]
-  [StorableClass(StorableClassType.Empty)]
+  [StorableClass]
   [Creatable("Test")]
   public class OrderBasedCrossover : PermutationCrossover {
Index: trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/OrderCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/OrderCrossover.cs	(revision 2997)
+++ trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/OrderCrossover.cs	(revision 3017)
@@ -35,5 +35,5 @@
   /// </remarks>
   [Item("OrderCrossover", "An operator which performs an order crossover of two permutations. It is implemented as described in Eiben, A.E. and Smith, J.E. 2003. Introduction to Evolutionary Computation. Natural Computing Series, Springer-Verlag Berlin Heidelberg.")]
-  [StorableClass(StorableClassType.Empty)]
+  [StorableClass]
   [Creatable("Test")]
   public class OrderCrossover : PermutationCrossover {
Index: trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/OrderCrossover2.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/OrderCrossover2.cs	(revision 2997)
+++ trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/OrderCrossover2.cs	(revision 3017)
@@ -34,5 +34,5 @@
   /// </remarks>
   [Item("OrderCrossover2", "An operator which performs an order crossover of two permutations. It is implemented as described in Affenzeller, M. et al. 2009. Genetic Algorithms and Genetic Programming - Modern Concepts and Practical Applications. CRC Press. p. 135.")]
-  [StorableClass(StorableClassType.Empty)]
+  [StorableClass]
   [Creatable("Test")]
   public class OrderCrossover2 : PermutationCrossover {
Index: trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/PartiallyMatchedCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/PartiallyMatchedCrossover.cs	(revision 2997)
+++ trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/PartiallyMatchedCrossover.cs	(revision 3017)
@@ -34,5 +34,5 @@
   /// </remarks>
   [Item("PartiallyMatchedCrossover", "An operator which performs the partially matched crossover on two permutations. It is implemented as described in Fogel, D.B. 1988. An Evolutionary Approach to the Traveling Salesman Problem. Biological Cybernetics, 60, pp. 139-144, Springer-Verlag.")]
-  [StorableClass(StorableClassType.Empty)]
+  [StorableClass]
   [Creatable("Test")]
   public class PartiallyMatchedCrossover : PermutationCrossover {
Index: trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/PositionBasedCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/PositionBasedCrossover.cs	(revision 2997)
+++ trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Crossovers/PositionBasedCrossover.cs	(revision 3017)
@@ -32,5 +32,5 @@
   /// </remarks>
   [Item("PositionBasedCrossover", "An operator which performs the position based crossover on two permutations. It is implemented as described in Syswerda, G. (1991). Schedule Optimization Using Genetic Algorithms. In Davis, L. (Ed.) Handbook of Genetic Algorithms, Van Nostrand Reinhold, New York, pp 332-349.")]
-  [StorableClass(StorableClassType.Empty)]
+  [StorableClass]
   [Creatable("Test")]
   public class PositionBasedCrossover : PermutationCrossover {
Index: trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Manipulators/InsertionManipulator.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Manipulators/InsertionManipulator.cs	(revision 2997)
+++ trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Manipulators/InsertionManipulator.cs	(revision 3017)
@@ -31,5 +31,5 @@
   /// </remarks>
   [Item("InsertionManipulator", "An operator which moves randomly one element to another position in the permutation. It is implemented as described in Fogel, D.B. (1988). An Evolutionary Approach to the Traveling Salesman Problem, Biological Cybernetics, 60, pp. 139-144.")]
-  [StorableClass(StorableClassType.Empty)]
+  [StorableClass]
   [Creatable("Test")]
   public class InsertionManipulator : PermutationManipulator {
Index: trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Manipulators/InversionManipulator.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Manipulators/InversionManipulator.cs	(revision 2997)
+++ trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Manipulators/InversionManipulator.cs	(revision 3017)
@@ -31,5 +31,5 @@
   /// </remarks>
   [Item("InversionManipulator", "An operator which inverts a randomly chosen part of a permutation. It is implemented as described in Eiben, A.E. and Smith, J.E. 2003. Introduction to Evolutionary Computation. Natural Computing Series, Springer-Verlag Berlin Heidelberg.")]
-  [StorableClass(StorableClassType.Empty)]
+  [StorableClass]
   [Creatable("Test")]
   public class InversionManipulator : PermutationManipulator {
Index: trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Manipulators/ScrambleManipulator.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Manipulators/ScrambleManipulator.cs	(revision 2997)
+++ trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Manipulators/ScrambleManipulator.cs	(revision 3017)
@@ -31,5 +31,5 @@
   /// </remarks>
   [Item("ScrambleManipulator", "An operator which manipulates a permutation array by randomly scrambling the elements in a randomly chosen interval. It is implemented as described in Syswerda, G. (1991). Schedule Optimization Using Genetic Algorithms. In Davis, L. (Ed.) Handbook of Genetic Algorithms, Van Nostrand Reinhold, New York, pp 332-349.")]
-  [StorableClass(StorableClassType.Empty)]
+  [StorableClass]
   [Creatable("Test")]
   public class ScrambleManipulator : PermutationManipulator {
Index: trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Manipulators/Swap2Manipulator.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Manipulators/Swap2Manipulator.cs	(revision 2997)
+++ trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Manipulators/Swap2Manipulator.cs	(revision 3017)
@@ -31,5 +31,5 @@
   /// </remarks>
   [Item("Swap2Manipulator", "An operator which manipulates a permutation array by swapping to randomly chosen elements. It is implemented as described in Eiben, A.E. and Smith, J.E. 2003. Introduction to Evolutionary Computation. Natural Computing Series, Springer-Verlag Berlin Heidelberg.")]
-  [StorableClass(StorableClassType.Empty)]
+  [StorableClass]
   [Creatable("Test")]
   public class Swap2Manipulator : PermutationManipulator {
Index: trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Manipulators/Swap3Manipulator.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Manipulators/Swap3Manipulator.cs	(revision 2997)
+++ trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Manipulators/Swap3Manipulator.cs	(revision 3017)
@@ -33,5 +33,5 @@
   /// </remarks>
   [Item("Swap3Manipulator", "An operator which manipulates a permutation array by swaping three randomly chosen elements. It is implemented such that first 3 positions are randomly chosen in the interval [0;N) with N = length of the permutation with all positions being distinct from each other. Then position 1 is put in place of position 3, position 2 is put in place of position 1 and position 3 is put in place of position 2.")]
-  [StorableClass(StorableClassType.Empty)]
+  [StorableClass]
   [Creatable("Test")]
   public class Swap3Manipulator : PermutationManipulator {
Index: trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Manipulators/TranslocationInversionManipulator.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Manipulators/TranslocationInversionManipulator.cs	(revision 2997)
+++ trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Manipulators/TranslocationInversionManipulator.cs	(revision 3017)
@@ -32,5 +32,5 @@
   /// </remarks>
   [Item("TranslocationInversionManipulator", "An operator which inverts a randomly chosen part of a permutation and inserts it at a random position. It is implemented as described in Fogel, D.B. 1993. Applying Evolutionary Programming to Selected TSP Problems, Cybernetics and Systems, 22, pp. 27-36.")]
-  [StorableClass(StorableClassType.Empty)]
+  [StorableClass]
   [Creatable("Test")]
   public class TranslocationInversionManipulator : PermutationManipulator {
Index: trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Manipulators/TranslocationManipulator.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Manipulators/TranslocationManipulator.cs	(revision 2997)
+++ trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Manipulators/TranslocationManipulator.cs	(revision 3017)
@@ -32,5 +32,5 @@
   /// </remarks>
   [Item("TranslocationManipulator", "An operator which Manipulates a permutation array by moving a randomly chosen interval of elements to another (randomly chosen) position in the array. It is implemented as described in Michalewicz, Z. 1992. Genetic Algorithms + Data Structures = Evolution Programs, Springer Verlag, Berlin Heidelberg.")]
-  [StorableClass(StorableClassType.Empty)]
+  [StorableClass]
   [Creatable("Test")]
   public class TranslocationManipulator : PermutationManipulator {
Index: trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/ExhaustiveTwoOptMoveGenerator.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/ExhaustiveTwoOptMoveGenerator.cs	(revision 2997)
+++ trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/ExhaustiveTwoOptMoveGenerator.cs	(revision 3017)
@@ -28,5 +28,5 @@
 namespace HeuristicLab.Encodings.Permutation {
   [Item("ExhaustiveTwoOptMoveGenerator", "Generates all possible 2-opt moves from a given permutation.")]
-  [StorableClass(StorableClassType.Empty)]
+  [StorableClass]
   public class ExhaustiveTwoOptMoveGenerator : SingleSuccessorOperator, IPermutationMoveGenerator {
     public ILookupParameter<Permutation> PermutationParameter {
Index: trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/TwoIndexMove.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/TwoIndexMove.cs	(revision 2997)
+++ trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/TwoIndexMove.cs	(revision 3017)
@@ -25,5 +25,5 @@
 namespace HeuristicLab.Encodings.Permutation {
   [Item("TwoIndexMove", "A move on a permutation that is specified by 2 indices")]
-  [StorableClass(StorableClassType.MarkedOnly)]
+  [StorableClass]
   public class TwoIndexMove : Item {
     [Storable]
Index: trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/TwoOptMove.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/TwoOptMove.cs	(revision 2997)
+++ trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/TwoOptMove.cs	(revision 3017)
@@ -25,5 +25,5 @@
 namespace HeuristicLab.Encodings.Permutation {
   [Item("TwoOptMove", "Item that describes a 2-Opt move.")]
-  [StorableClass(StorableClassType.Empty)]
+  [StorableClass]
   public class TwoOptMove : TwoIndexMove {
     public TwoOptMove()
Index: trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/TwoOptMoveMaker.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/TwoOptMoveMaker.cs	(revision 2997)
+++ trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/TwoOptMoveMaker.cs	(revision 3017)
@@ -29,5 +29,5 @@
 namespace HeuristicLab.Encodings.Permutation {
   [Item("TwoOptMoveMaker", "Peforms a 2-opt move on a given permutation and updates the quality.")]
-  [StorableClass(StorableClassType.Empty)]
+  [StorableClass]
   public class TwoOptMoveMaker : SingleSuccessorOperator {
     public LookupParameter<DoubleData> QualityParameter {
Index: trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/TwoOptMoveTabuAttribute.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/TwoOptMoveTabuAttribute.cs	(revision 2997)
+++ trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/TwoOptMoveTabuAttribute.cs	(revision 3017)
@@ -25,5 +25,5 @@
 namespace HeuristicLab.Encodings.Permutation {
   [Item("TwoOptMoveTabuAttribute", "Specifies the tabu attributes for a 2-opt move.")]
-  [StorableClass(StorableClassType.MarkedOnly)]
+  [StorableClass]
   public class TwoOptMoveTabuAttribute : Item {
     [Storable]
Index: trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/TwoOptMoveTabuEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/TwoOptMoveTabuEvaluator.cs	(revision 2997)
+++ trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/TwoOptMoveTabuEvaluator.cs	(revision 3017)
@@ -29,5 +29,5 @@
 namespace HeuristicLab.Encodings.Permutation {
   [Item("TwoOptMoveTabuEvaluator", "Evaluates whether a given 2-opt move is tabu.")]
-  [StorableClass(StorableClassType.Empty)]
+  [StorableClass]
   public class TwoOptMoveTabuEvaluator : SingleSuccessorOperator {
     public LookupParameter<TwoOptMove> MoveParameter {
Index: trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/TwoOptMoveTabuMaker.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/TwoOptMoveTabuMaker.cs	(revision 2997)
+++ trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/TwoOptMoveTabuMaker.cs	(revision 3017)
@@ -29,5 +29,5 @@
 namespace HeuristicLab.Encodings.Permutation.Moves {
   [Item("TwoOptMoveTabuMaker", "Declares a given 2-opt move as tabu, by adding its attributes to the tabu list. It also removes the oldest entry in the tabu list when its size is greater than tenure.")]
-  [StorableClass(StorableClassType.Empty)]
+  [StorableClass]
   public class TwoOptMoveTabuMaker : SingleSuccessorOperator {
     public LookupParameter<TwoOptMove> MoveParameter {
Index: trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Permutation.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Permutation.cs	(revision 2997)
+++ trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Permutation.cs	(revision 3017)
@@ -28,5 +28,5 @@
 
 namespace HeuristicLab.Encodings.Permutation {
-  [StorableClass(StorableClassType.Empty)]
+  [StorableClass]
   [Item("Permutation", "Represents a permutation of integer values.")]
   [Creatable("Test")]
Index: trunk/sources/HeuristicLab.Encodings.Permutation/3.3/PermutationCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.Permutation/3.3/PermutationCrossover.cs	(revision 2997)
+++ trunk/sources/HeuristicLab.Encodings.Permutation/3.3/PermutationCrossover.cs	(revision 3017)
@@ -31,5 +31,5 @@
   /// </summary>
   [Item("PermutationCrossover", "A base class for permutation crossover operators.")]
-  [StorableClass(StorableClassType.Empty)]
+  [StorableClass]
   public abstract class PermutationCrossover : SingleSuccessorOperator, IPermutationCrossover, IStochasticOperator {
     public ILookupParameter<IRandom> RandomParameter {
Index: trunk/sources/HeuristicLab.Encodings.Permutation/3.3/PermutationManipulator.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.Permutation/3.3/PermutationManipulator.cs	(revision 2997)
+++ trunk/sources/HeuristicLab.Encodings.Permutation/3.3/PermutationManipulator.cs	(revision 3017)
@@ -31,5 +31,5 @@
   /// </summary>
   [Item("PermutationManipulator", "A base class for permutation manipulation operators.")]
-  [StorableClass(StorableClassType.Empty)]
+  [StorableClass]
   public abstract class PermutationManipulator : SingleSuccessorOperator, IPermutationManipulator, IStochasticOperator {
     public ILookupParameter<IRandom> RandomParameter {